﻿<!DOCTYPE html>

<html lang="en" xmlns="http://www.w3.org/1999/xhtml">
<head>
    <meta charset="utf-8" />
    <title>Sim30</title>

    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.2.1/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/tether/1.4.0/js/tether.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.0.0-alpha.6/js/bootstrap.min.js"></script>

    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/tether/1.4.0/css/tether.min.css" />
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.0.0-alpha.6/css/bootstrap.min.css" />

    <style>
        html, body {
            height: 100%;
        }

        .row {
            margin: 0;
        }

        textarea {
            width: calc(100% - 8px);
            padding: 0.2em;
        }

        #inputSourceCode {
            height: 100%;
        }
    </style>
</head>
<body>
    <h2 style="margin-left:16px;">SIM30 as a Service</h2>
    <form>
        <input type="hidden" id="sid" />
        <div class="row">
            <div class="col-sm-6">
                <h4>Code</h4>
                <textarea id="inputSourceCode" cols="80"></textarea>
            </div>
            <div class="col-sm-6">
                <h4>Result</h4>
                <textarea id="outputResult" cols="80" rows="20"></textarea>
                <h4>Command</h4>
                <textarea id="inputCommand" cols="80" rows="6"></textarea>
                <section>
                    <button type="button" id="btnCompile">Compile</button>
                    <button type="button" id="btnRun" class="btn-actions">Run</button>
                    <button type="button" id="btnAsm" class="btn-code btn-actions">ASM</button>
                    <button type="button" id="btnLis" class="btn-code btn-actions">LIS</button>
                    <button type="button" id="btnObj" class="btn-code btn-actions">OBJ</button>
                    <button type="reset" id="btnReset">Reset</button>
                </section>
            </div>
        </div>

    </form>
</body>
</html>

<script>
    $(document).ready(function () {
        ResetActions();
    });

    $('#btnCompile').click(function (e) {
        var sourceCode = $('#inputSourceCode').val();

        if (sourceCode == "")
            return;

        var data = {
            "SourceCode": sourceCode
        }

        $.ajax({
            type: "POST",
            url: 'http://localhost:80/api/sim30/compile',
            crossDomain: true,
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            data: JSON.stringify(data),
            success: function (response) {
                if (response.Compiled)
                {
                    $("#sid").val(response.Sid);
                    AddResult("Compiled!\n");
                }
                else
                {
                    AddResult(response.Message);
                }

                ResetActions();
            },
            failure: function (errMsg) {
                alert(errMsg);
                ResetActions();
            }
        });
    });

    $('#btnRun').click(function (e) {
        Run();
    });

    $("#inputCommand").keypress(function (e) {
        var code = (e.keyCode ? e.keyCode : e.which);
        if (code == 13) {
            Run();
            return true;
        }
    });

    function Run()
    {
        var sourceCode = $('#inputSourceCode').val();
        var sid = $("#sid").val();
        var command = $("#inputCommand").val();

        if (sourceCode == '' || sid == '')
            return;
     
        AddResult("\n> " + command + "\n");

        $.ajax({
            type: "GET",
            url: 'http://localhost:80/api/sim30/execute?' + 'sid=' + sid + '&Command=' + command,
            crossDomain: true,
            success: function (data) {
                AddResult(data);
                $("#inputCommand").val('').focus();
                var textarea = document.getElementById('outputResult');
                textarea.scrollTop = textarea.scrollHeight;
            },
            failure: function (errMsg) {
                alert(errMsg);
            }
        });
    }

    $('.btn-code').click(function (e) {
        var sid = $("#sid").val();
        var typ = $(this).text();
        if (sid == '' || typ == '')
            return;

        window.open('http://localhost:80/api/sim30/src?' + 'sid=' + sid + '&typ=' + typ , '_blank'); 
    });

    $('#btnReset').click(function (e) {
        ResetScreen();
    });

    function ResetScreen()
    {
        $(':input').val('');
        $('#outputResult').html('');
        ResetActions();
    }

    function ResetActions()
    {
        $('.btn-actions').prop('disabled', true);

        if ($("#sid").val() != "") {
            $('.btn-actions').prop('disabled', false);
        }
    }

    function AddResult(result)
    {
        $("#outputResult").append(result);
    }
</script>